#
# spec file for package read-only-root-fs
#
# Copyright (c) 2018 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           read-only-root-fs
Version:        1.0+git20180418.4373cf9
Release:        lp150.1.1
Summary:        Files and Scripts for a RO root fileystem
License:        GPL-2.0-or-later
Group:          System/Fhs
Url:            https://github.com/openSUSE/read-only-root-fs
Source:         read-only-root-fs-%{version}.tar.xz
Source1:        README.packaging.txt
BuildRequires:  dracut
Requires:       dracut
Requires(post): coreutils
Requires(post): grep
Requires:       sed
BuildArch:      noarch

%description
Files, scripts and directories to run the system with a
read-only root filesystem with %{_sysconfdir} writeable via overlayfs.

This package should never be installed in an already running
system! It should only be selected by a system role for a
read-only root filesystem with transactional updates.
A new file /etc/fstab.sys is created and included in the initrd.
The multiversion features of libzypp and the purge-kernel service
will be disabled.

%package volatile
Summary:        Dracut Module to mount a tmpfs overlay on a RO root
Group:          System/Fhs
Requires:       dracut

%description volatile
A dracut module which mounts an overlayfs each on /etc and /var, with the upper
layer in a tmpfs mount. This is the minimal setup to get a booting system, to
have a writable /root or /home, additional fstab entries can be added.

%prep
%setup -q

%build

%install
cp -a usr %{buildroot}
mkdir -p %{buildroot}%{_localstatedir}/lib/overlay/{etc,work-etc}

%post
if [ -f %{_sysconfdir}/fstab -a ! -f %{_sysconfdir}/fstab.sys ]; then
  %{_sbindir}/setup-fstab.sys-for-overlayfs ||:
fi
exit 0

%posttrans
if [ -f /etc/zypp/zypp.conf ]; then
    sed -i 's/^multiversion =.*/multiversion =/g' /etc/zypp/zypp.conf
fi
exit 0

%files
%license COPYING
%{_sbindir}/setup-fstab.sys-for-overlayfs
%{_localstatedir}/lib/overlay
%{_prefix}/lib/dracut/modules.d/99read-only-root-fs
%{_prefix}/lib/systemd/system-preset/*

%files volatile
%license COPYING
%{_prefix}/lib/dracut/modules.d/99volatile-overlay/

%changelog
* Wed Apr 18 2018 fvogt@suse.com
- Update to version 1.0+git20180418.4373cf9:
  * Fix 99volatile-overlay
  * proper shell escaping in mount-overlay.sh (#3)
* Mon Apr 16 2018 fvogt@suse.com
- Update to version 1.0+git20180416.825ad6c:
  * Add new 99volatile-overlay dracut module
- BuildRequire/Require dracut for proper directory ownership
- Fix posttrans if zypper is not installed
* Wed Mar 21 2018 kukuk@suse.de
- Disable multiversion feature of libzypp at install time
- Document, that this package should never be installed in a
  running system, only during installation
* Wed Mar 21 2018 kukuk@suse.de
- Update to version 1.0+git20180321.a5b34ab:
  * Disable purge-kernels.service, does not work with read-only
    root filesystem
  * Enable man-db-create.service, man cannot create cache in %%post
  * Fix OBS URL
* Fri Mar  2 2018 rbrown@suse.com
- Add Requires(post) for coreutils & grep to ensure post script has
  what it needs (boo#1083526)
* Tue Feb 27 2018 kukuk@suse.de
- Update to version 1.0+git20180227.44d5e8a:
  * Initial import of read-only-root-fs stuff from caasp-tools
* Tue Feb 27 2018 kukuk@suse.de
- Initial version
